/*
 * $Id: logger.d,v 1.1.1.1 2006/02/19 04:57:26 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
module abagames.util.logger;

private import std.c.stdio;
private import std.string;

/**
 * Logger(error/info).
 */
version(Win32_release) {

private import std.string;
private import std.c.windows.windows;

public class Logger {

  public static void info(char[] msg, bool nline = true) {
  }

  public static void info(double n, bool nline = true) {
  }

  private static void putMessage(char[] msg) {
    MessageBoxA(null, std.string.toStringz(msg), "Error", MB_OK | MB_ICONEXCLAMATION);
  }

  public static void error(char[] msg) {
    putMessage("Error: " ~ msg);
  }

  public static void error(Exception e) {
    putMessage("Error: " ~ e.toString());
  }

  public static void error(Error e) {
    putMessage("Error: " ~ e.toString());
  }
}

} else {

public class Logger {

  public static void info(char[] msg, bool nline = true) {
    if (nline)
      printf(msg ~ "\n");
    else
      printf(msg);
  }

  public static void info(double n, bool nline = true) {
    if (nline)
      printf(std.string.toString(n)~ "\n");
    else
      printf(std.string.toString(n) ~ " ");
  }

  public static void error(char[] msg) {
    printf("Error: " ~ msg);
  }

  public static void error(Exception e) {
    printf("Error: " ~ e.toString());
  }

  public static void error(Error e) {
    printf("Error: " ~ e.toString());
    if (e.next)
      error(e.next);
  }
}

}
